What's the purpose of “true” in bash “if sudo true; then”How can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?

Why is Minecraft giving an OpenGL error?

Is it possible to do 50 km distance without any previous training?

What typically incentivizes a professor to change jobs to a lower ranking university?

Alternative to sending password over mail?

What does it mean to describe someone as a butt steak?

How do I deal with an unproductive colleague in a small company?

definition of observer and time measured by different observers in general relativity

Why doesn't a class having private constructor prevent inheriting from this class? How to control which classes can inherit from a certain base?

Modeling an IP Address

How can bays and straits be determined in a procedurally generated map?

Operational amplifier as comparator at high frequency

Can a monk's single staff be considered dual wielded, as per the Dual Wielder feat?

How old can references or sources in a thesis be?

Are astronomers waiting to see something in an image from a gravitational lens that they've already seen in an adjacent image?

Question relative to pads for capacitors - high frequency

Do I have a twin with permutated remainders?

Has there ever been an airliner design involving reducing generator load by installing solar panels?

Important Resources for Dark Age Civilizations?

How much RAM could one put in a typical 80386 setup?

Why does Kotter return in Welcome Back Kotter?

Question on branch cuts and branch points

Roll the carpet

Can a Cauchy sequence converge for one metric while not converging for another?

dbcc cleantable batch size explanation



What's the purpose of “true” in bash “if sudo true; then”


How can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?






.everyoneloves__top-leaderboard:empty,.everyoneloves__mid-leaderboard:empty,.everyoneloves__bot-mid-leaderboard:empty margin-bottom:0;








19















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question



















  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24


















19















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question



















  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24














19












19








19








I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question
















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then






bash sudo






share|improve this question















share|improve this question













share|improve this question




share|improve this question








edited Mar 27 at 12:00







Matt Parkins

















asked Mar 26 at 14:43









Matt ParkinsMatt Parkins

20727




20727







  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24













  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24








2




2





If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
Mar 26 at 14:47






If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
Mar 26 at 14:47





4




4





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
Mar 26 at 14:52





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
Mar 26 at 14:52




1




1





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
Mar 26 at 14:55





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
Mar 26 at 14:55




1




1





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
Mar 26 at 15:15





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
Mar 26 at 15:15




2




2





In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
Mar 26 at 17:24






In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
Mar 26 at 17:24











3 Answers
3






active

oldest

votes


















38














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer


















  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 2





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 1





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15


















19














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13


















5














As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer




















  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29











Your Answer








StackExchange.ready(function()
var channelOptions =
tags: "".split(" "),
id: "106"
;
initTagRenderer("".split(" "), "".split(" "), channelOptions);

StackExchange.using("externalEditor", function()
// Have to fire editor after snippets, if snippets enabled
if (StackExchange.settings.snippets.snippetsEnabled)
StackExchange.using("snippets", function()
createEditor();
);

else
createEditor();

);

function createEditor()
StackExchange.prepareEditor(
heartbeatType: 'answer',
autoActivateHeartbeat: false,
convertImagesToLinks: false,
noModals: true,
showLowRepImageUploadWarning: true,
reputationToPostImages: null,
bindNavPrevention: true,
postfix: "",
imageUploader:
brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
allowUrls: true
,
onDemand: true,
discardSelector: ".discard-answer"
,immediatelyShowMarkdownHelp:true
);



);













draft saved

draft discarded


















StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown

























3 Answers
3






active

oldest

votes








3 Answers
3






active

oldest

votes









active

oldest

votes






active

oldest

votes









38














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer


















  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 2





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 1





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15















38














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer


















  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 2





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 1





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15













38












38








38







true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer













true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;






share|improve this answer












share|improve this answer



share|improve this answer










answered Mar 26 at 14:58









JShorthouseJShorthouse

52728




52728







  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 2





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 1





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15












  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 2





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 1





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15







12




12





As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

– IMSoP
Mar 26 at 19:11






As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

– IMSoP
Mar 26 at 19:11





30




30





PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

– IMSoP
Mar 26 at 19:14






PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

– IMSoP
Mar 26 at 19:14





2




2





@IMSoP That's deep.

– brainplot
Mar 27 at 12:54





@IMSoP That's deep.

– brainplot
Mar 27 at 12:54




1




1





If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

– nigel222
Mar 27 at 17:22





If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

– nigel222
Mar 27 at 17:22




1




1





In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

– Lee Daniel Crocker
Mar 27 at 20:15





In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

– Lee Daniel Crocker
Mar 27 at 20:15













19














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13















19














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13













19












19








19







I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer













I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.







share|improve this answer












share|improve this answer



share|improve this answer










answered Mar 26 at 22:32









MehrdadMehrdad

1,39641534




1,39641534







  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13












  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13







1




1





Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

– Sergiy Kolodyazhnyy
Mar 27 at 3:32





Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

– Sergiy Kolodyazhnyy
Mar 27 at 3:32




3




3





Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

– Mehrdad
Mar 27 at 3:38






Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

– Mehrdad
Mar 27 at 3:38





1




1





The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

– mckenzm
Mar 27 at 4:10





The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

– mckenzm
Mar 27 at 4:10




2




2





And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

– Dave Sherohman
Mar 27 at 14:42





And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

– Dave Sherohman
Mar 27 at 14:42




2




2





Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

– jrw32982
Mar 27 at 19:13





Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

– jrw32982
Mar 27 at 19:13











5














As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer




















  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29















5














As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer




















  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29













5












5








5







As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer















As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.







share|improve this answer














share|improve this answer



share|improve this answer








edited Mar 26 at 15:06

























answered Mar 26 at 14:55









Luciano Andress MartiniLuciano Andress Martini

4,1901237




4,1901237







  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29












  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29







1




1





The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

– ilkkachu
Mar 26 at 15:10





The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

– ilkkachu
Mar 26 at 15:10













I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

– Luciano Andress Martini
Mar 26 at 15:29





I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

– Luciano Andress Martini
Mar 26 at 15:29

















draft saved

draft discarded
















































Thanks for contributing an answer to Unix & Linux Stack Exchange!


  • Please be sure to answer the question. Provide details and share your research!

But avoid


  • Asking for help, clarification, or responding to other answers.

  • Making statements based on opinion; back them up with references or personal experience.

To learn more, see our tips on writing great answers.




draft saved


draft discarded














StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown





















































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown

































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown







Popular posts from this blog

Adding axes to figuresAdding axes labels to LaTeX figuresLaTeX equivalent of ConTeXt buffersRotate a node but not its content: the case of the ellipse decorationHow to define the default vertical distance between nodes?TikZ scaling graphic and adjust node position and keep font sizeNumerical conditional within tikz keys?adding axes to shapesAlign axes across subfiguresAdding figures with a certain orderLine up nested tikz enviroments or how to get rid of themAdding axes labels to LaTeX figures

Luettelo Yhdysvaltain laivaston lentotukialuksista Lähteet | Navigointivalikko

Gary (muusikko) Sisällysluettelo Historia | Rockin' High | Lähteet | Aiheesta muualla | NavigointivalikkoInfobox OKTuomas "Gary" Keskinen Ancaran kitaristiksiProjekti Rockin' High